## pam-wrapper 1.1.8

=== CMakeLists.txt ===
# Required cmake version
cmake_minimum_required(VERSION 3.20.0)
cmake_policy(SET CMP0048 NEW)

# Specify search path for CMake modules to be loaded by include()
# and find_package()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

# Add defaults for cmake
# Those need to be set before the project() call.
include(DefineCMakeDefaults)
include(DefineCompilerFlags)

project(pam_wrapper VERSION 1.1.8 LANGUAGES C)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

# SOVERSION scheme: MAJOR.MINOR.PATCH
#   If there was an incompatible interface change:
#     Increment MAJOR. Set MINOR and PATCH to 0
#   If there was a compatible interface change:
#     Increment MINOR. Set PATCH to 0
#   If the source code was changed, but there were no interface changes:
#     Increment PATCH.
set(LIBRARY_VERSION_MAJOR 0)
set(LIBRARY_VERSION_MINOR 0)
set(LIBRARY_VERSION_PATCH 11)
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

set(PAMTEST_LIBRARY_VERSION_MAJOR 1)
set(PAMTEST_LIBRARY_VERSION_MINOR 0)
set(PAMTEST_LIBRARY_VERSION_PATCH 0)
set(PAMTEST_LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PAMTEST_LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

# add definitions
include(DefinePlatformDefaults)
include(GNUInstallDirs)
include(DefineOptions.cmake)
include(CPackConfig.cmake)
include(CompilerChecks.cmake)

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(include)
add_subdirectory(src)

if (UNIT_TESTING)
    find_package(CMocka 1.1.0 REQUIRED)
    include(AddCMockaTest)
    add_subdirectory(tests)
endif (UNIT_TESTING)

# Link compile database for clangd
execute_process(COMMAND cmake -E create_symlink
                "${CMAKE_BINARY_DIR}/compile_commands.json"
                "${CMAKE_SOURCE_DIR}/compile_commands.json")
# pkg-config file
get_filename_component(PAM_WRAPPER_LIB ${PAM_WRAPPER_LOCATION} NAME)

configure_file(pam_wrapper.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper.pc
  DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT
    pkgconfig
)

configure_file(libpamtest.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libpamtest.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/libpamtest.pc
  DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT
    pkgconfig
)

# cmake config files
include(CMakePackageConfigHelpers)

write_basic_package_version_file(pam_wrapper-config-version.cmake
                                 COMPATIBILITY
                                     AnyNewerVersion)
configure_file(pam_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config.cmake @ONLY)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config.cmake
    DESTINATION
        ${CMAKE_INSTALL_LIBDIR}/cmake/pam_wrapper
    COMPONENT
        devel
)

write_basic_package_version_file(pamtest-config-version.cmake
                                 COMPATIBILITY
                                     AnyNewerVersion)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pamtest-config-version.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pamtest
        COMPONENT devel)

add_subdirectory(doc)

=== src/CMakeLists.txt ===
project(libpam_wrapper C)

###########################################################
### pam_wrapper
###########################################################

add_library(pam_wrapper SHARED pam_wrapper.c)
target_include_directories(pam_wrapper
                           PRIVATE
                               ${pam_wrapper-headers_SOURCE_DIR}
                               ${pam_wrapper_BINARY_DIR})

set(PAM_WRAPPER_LIBRARIES
	${PAMWRAP_REQUIRED_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT})
if (HAVE_OPENPAM)
	list(APPEND PAM_WRAPPER_LIBRARIES pam)
endif (HAVE_OPENPAM)

target_link_libraries(pam_wrapper ${PAM_WRAPPER_LIBRARIES} ${DLFCN_LIBRARY})

target_compile_options(pam_wrapper
                       PRIVATE ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE=1)

set_target_properties(
  pam_wrapper
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
)

install(TARGETS pam_wrapper
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

###########################################################
### libpamtest
###########################################################

set(pamtest_SOURCES
    libpamtest.c
)

set(PAM_LIBRARIES pam)
if (HAVE_PAM_MISC)
	list(APPEND PAM_LIBRARIES pam_misc)
endif (HAVE_PAM_MISC)

add_library(pamtest SHARED ${pamtest_SOURCES})
target_include_directories(pamtest
                           PRIVATE
                               ${pam_wrapper_BINARY_DIR}
                           PUBLIC
                               $<BUILD_INTERFACE:${pam_wrapper-headers_SOURCE_DIR}>
                               $<INSTALL_INTERFACE:include>)
add_library(pamtest::pamtest ALIAS pamtest)

target_link_libraries(pamtest ${PAM_LIBRARIES})
target_compile_options(pamtest
                       PRIVATE ${DEFAULT_C_COMPILE_FLAGS})

set_target_properties(pamtest
    PROPERTIES
        VERSION ${LIBRARY_VERSION}
        SOVERSION ${LIBRARY_SOVERSION})

install(TARGETS pamtest
        EXPORT pamtest-config
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(EXPORT pamtest-config
        NAMESPACE pamtest::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pamtest)

add_subdirectory(modules)
add_subdirectory(python)

# This needs to be at the end
set(PAM_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}pam_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}" PARENT_SCOPE)

=== tests/CMakeLists.txt ===
project(tests C)

if (TARGET cmocka::cmocka)
    set(CMOCKA_LIBRARY cmocka::cmocka)
endif()

set(PAM_MATRIX_PATH "${CMAKE_BINARY_DIR}/src/modules/pam_matrix.so")

configure_file(services/matrix.in ${CMAKE_CURRENT_BINARY_DIR}/services/matrix @ONLY)

# Some tests use a passdb as argument for pam_matrix
set(PASSDB_RO_PATH ${CMAKE_CURRENT_BINARY_DIR}/passdb_ro)
configure_file(passdb_ro ${PASSDB_RO_PATH} @ONLY)
configure_file(services/matrix_opt.in ${CMAKE_CURRENT_BINARY_DIR}/services/matrix_opt @ONLY)

set(PASSDB_PY_PATH ${CMAKE_CURRENT_BINARY_DIR}/passdb_py)
configure_file(passdb_py ${PASSDB_PY_PATH} @ONLY)
configure_file(services/matrix_py.in ${CMAKE_CURRENT_BINARY_DIR}/services/matrix_py @ONLY)

configure_file(services/pwrap_get_set.in ${CMAKE_CURRENT_BINARY_DIR}/services/pwrap_get_set @ONLY)

set(PAM_CHATTY_PATH "${CMAKE_BINARY_DIR}/src/modules/pam_chatty.so")
configure_file(services/chatty.in ${CMAKE_CURRENT_BINARY_DIR}/services/chatty @ONLY)

function(ADD_CMOCKA_TEST_ENVIRONMENT _TEST_NAME)
    if (CMAKE_BUILD_TYPE)
        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer")
            find_library(ASAN_LIBRARY
                         NAMES asan)
            if (NOT ASAN_LIBRARY)
                foreach(version RANGE 10 1)
                    if (NOT ASAN_LIBRARY)
                        find_library(ASAN_LIBRARY libasan.so.${version})
                    endif()
                endforeach()
            endif()
        endif()
    endif()

    if (ASAN_LIBRARY)
        list(APPEND PRELOAD_LIBRARIES ${ASAN_LIBRARY})
    endif()
    list(APPEND PRELOAD_LIBRARIES ${PAM_WRAPPER_LOCATION})

    if (OSX)
        set(TORTURE_ENVIRONMENT "DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${RESOLV_WRAPPER_LOCATION}:${SOCKET_WRAPPER_LIBRARY}")
    else ()
        string(REPLACE ";" ":" _TMP_ENV "${PRELOAD_LIBRARIES}")
        set(TORTURE_ENVIRONMENT "LD_PRELOAD=${_TMP_ENV}")
    endif()

    list(APPEND TORTURE_ENVIRONMENT PAM_WRAPPER=1)
    list(APPEND TORTURE_ENVIRONMENT PAM_WRAPPER_SERVICE_DIR=${CMAKE_CURRENT_BINARY_DIR}/services)

    foreach(_arg ${ARGN})
        list(APPEND TORTURE_ENVIRONMENT ${_arg})
    endforeach()

    set_property(TEST
                    ${_TEST_NAME}
                PROPERTY
                    ENVIRONMENT "${TORTURE_ENVIRONMENT}")
endfunction()

set(PAM_LIBRARIES pam)
if (HAVE_PAM_MISC)
	list(APPEND PAM_LIBRARIES pam_misc)
endif (HAVE_PAM_MISC)

set(TEST_LIBRARIES
    pamtest
    ${CMOCKA_LIBRARY}
    ${PAM_LIBRARIES}
)

add_cmocka_test(test_pam_wrapper
                SOURCES test_pam_wrapper.c
                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS}
                LINK_LIBRARIES ${TEST_LIBRARIES})
target_include_directories(test_pam_wrapper
                           PRIVATE
                               ${CMOCKA_INCLUDE_DIR}
                               ${pam_wrapper_BINARY_DIR})
add_cmocka_test_environment(test_pam_wrapper)

# Do not run python tests with AddressSanitizer
set(RUN_PYTHON_TESTS ON)
if (CMAKE_BUILD_TYPE)
    string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
    if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer")
        set(RUN_PYTHON_TESTS OFF)
    endif()
endif()

if (RUN_PYTHON_TESTS)
    find_package(Python 3.10 COMPONENTS Interpreter)
    if (Python_Interpreter_FOUND)
        add_test(NAME
                    py3pamtest_test
                 COMMAND
                    ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/pypamtest_test.py)

        add_cmocka_test_environment(py3pamtest_test)
    endif()
endif()

=== src/python/CMakeLists.txt ===
project(pypamtest C)

add_subdirectory(python3)

if (WITH_WNO_CAST_FUNCTION_TYPE)
    set_source_files_properties(pypamtest.c
                                DIRECTORY python3
                                PROPERTIES COMPILE_OPTIONS "-Wno-cast-function-type")
endif()

=== src/python/python3/CMakeLists.txt ===
project(python3-pamtest C)

find_package(Python 3.10 COMPONENTS Development Interpreter)
# Allow to specify sitearch dir on the commandline
if (NOT PYTHON_INSTALL_SITEARCH)
    set(PYTHON_INSTALL_SITEARCH ${Python_SITEARCH})
endif()

if (Python_Development_FOUND)
    add_library(python3-pamtest
                MODULE ${pypamtest_SOURCE_DIR}/pypamtest.c)
    target_compile_options(python3-pamtest
                           PRIVATE ${DEFAULT_C_COMPILE_FLAGS})
    target_include_directories(python3-pamtest
                               PRIVATE
                                   ${pam_wrapper_BINARY_DIR}
                                   ${pam_wrapper-headers_DIR})
    target_link_libraries(python3-pamtest PRIVATE pamtest::pamtest Python::Python)
    set_property(TARGET python3-pamtest PROPERTY PREFIX "")
    set_property(TARGET python3-pamtest PROPERTY OUTPUT_NAME "pypamtest")

    install(TARGETS
                python3-pamtest
            DESTINATION
                ${PYTHON_INSTALL_SITEARCH})
endif()

=== debian/changelog ===
pam-wrapper (1.1.8-1) unstable; urgency=medium

  * New upstream version 1.1.8
  * Standards-Version: 4.7.2.
  * Bump debian/* copyright years.
  * Run wrap-and-sort -satbk.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 17 Aug 2025 13:05:51 +0200

=== debian/control ===
Source: pam-wrapper
Priority: optional
Maintainer: Debian SSSD Team <pkg-sssd-devel@alioth-lists.debian.net>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 cmake,
 libpam0g-dev,
 python3-dev,
 python3-setuptools,
X-Python3-Version: >= 3.6
Standards-Version: 4.7.2
Section: devel
Homepage: https://cwrap.org/pam_wrapper.html
Vcs-Git: https://salsa.debian.org/sssd-team/pam-wrapper.git
Vcs-Browser: https://salsa.debian.org/sssd-team/pam-wrapper
Rules-Requires-Root: no

Package: libpam-wrapper
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Tool to test PAM applications
 This component of cwrap allows you to test your PAM (Linux-PAM and OpenPAM)
 application.
 .
 For testing PAM applications, simple PAM module called pam_matrix is
 included.

Package: libpamtest0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libpam-wrapper (<< 1.0.7-3),
Breaks:
 libpam-wrapper (<< 1.0.7-3),
Description: Library to test PAM modules
 This component of cwrap allows you to test your PAM (Linux-PAM and OpenPAM)
 module.
 .
 For testing a PAM module you can use the pamtest library, which simplifies
 testing of modules. You can combine it with the cmocka unit testing framework
 or you can use the provided Python bindings to write tests for your module in
 Python.
 .
 This package provides shared libraries.

Package: libpamtest0-dev
Architecture: any
Multi-Arch: same
Depends:
 libpamtest0 (= ${binary:Version}),
 ${misc:Depends},
Replaces:
 libpam-wrapper (<< 1.0.7-3),
Breaks:
 libpam-wrapper (<< 1.0.7-3),
Description: Development files for library to test PAM modules
 This component of cwrap allows you to test your PAM (Linux-PAM and OpenPAM)
 module.
 .
 For testing a PAM module you can use the pamtest library, which simplifies
 testing of modules. You can combine it with the cmocka unit testing framework
 or you can use the provided Python bindings to write tests for your module in
 Python.
 .
 This package provides development headers.

Package: python3-pypamtest
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Tool to test PAM applications and PAM modules -- Python3 bindings
 This component of cwrap allows you to either test your PAM (Linux-PAM
 and OpenPAM) application or module.
 .
 This package includes bindings for Python 3.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://ftp.samba.org/pub/cwrap/ \
pam_wrapper-@ANY_VERSION@@ARCHIVE_EXT@
